/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _ENTITYLINE_H_
#define _ENTITYLINE_H_

#include "entityWithValue.h"

class EntityLine: public EntityWithPosition
{
public:
	EntityLine(float interval, bool visible, Vector3 axis, 
			   Vector3 center, Vector3 rotAxis, float angle);	
	
	EntityLine(int size, float interval, bool visible, Material *material, Mesh *mesh, Vector3 axis, 
			   Vector3 center, Vector3 rotAxis, float angle);
	~EntityLine();

	void insertChild(Material *material, Mesh *mesh, int value, int position);
			
	int getValue(int position);
		
	bool setValue(int value, int position);
	bool setValueAndMaterial(int value, Material *material, int position);
		
	void setClickable();
		
protected:	
	float mInterval;
	Vector3 mAxis;
};




#endif // _ENTITYLINE_H_
