/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _ENTITY2D_H_
#define _ENTITY2D_H_

#include "material.h"


class Entity2D
{
public:
	Entity2D(Material *material, bool visible);
	Entity2D(Material *material, bool visible, int numClick);
	~Entity2D();
		
	int getNumClick();
	void setNumClick(int numClick);
	void setVisibility(bool visible);
		
	Material* getMaterial(void);
	void setMaterial(Material* material);
	
	virtual void drawGeometry() = 0;
	void render();
		
protected:
    Material* mpMaterial;
		
	int mNumClick;
	bool mVisible;
};

#endif // _ENTITY2D_H_
