/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _NEWTPUZZLE_H_
#define _NEWTPUZZLE_H_

#include <vector>

#include "newtState.h"
#include "game.h"
#include "./gameChooser/gameChooser.h"
#include "menu.h"

#include "./ticTacToe/ticTacToe.h"
 
#include "./scoreFour/scoreFour.h"
 
#include "./keplerBubble/keplerBubble.h"
 
#include "./newtEngine/display3D.h"
 
enum newtStateName {NP_CHOOSER, NP_GAME, NP_MENU, NP_OPTIONS, NP_RULES};



class NewtPuzzle
{
public:
	NewtPuzzle();
	~NewtPuzzle();
				
	Game* getCurrentGame();
	//Menu* getCurrentMenu();
		
	NewtState* getNewtCurrentState();
		
	newtGame getNameGame();
	newtStateName getStateName();
	
	void launch(newtGame selectedLauncher);
			
	void quitCurrentNewtState();
				
	bool keyboardEvent(SDLKey key, double timeInterval);
		
		
private:
	newtGame nameGame;
	newtStateName stateName;
			
	NewtState *currentNewtState;
		
	GameChooser *chooser;		
		
	Game *currentGame;
	//Menu *currentMenu;
		
	
};

extern NewtPuzzle *newt;


#endif // _NEWTPUZZLE_H_
